<template lang="html">
  <div class="are-you-sure-dialog">
    <div class="content">
      <div class="text-content">
        <h3>{{ areYouSureDetails.message }}</h3>
      </div>
      <div class="options-container">
        <div class="cancel-btn-container">
          <button class="cancel-btn"
            v-on:click="closeDialog()">{{ label.CANCEL }}</button>
        </div>
        <div class="accept-btn-container">
          <button class="accept-btn"
            v-on:click="onYes()">{{ label.ACCEPT }}</button>
        </div>
      </div>
      <div v-if="showSpinner" class="spinner-icon-container">
        <ep-spinner class="spinner-icon"></ep-spinner>
      </div>
    </div>
  </div>
</template>

<script>
import { mapState, mapActions } from 'vuex'

import Spinner from '../Spinner'

export default {
  name: 'ep-are-you-sure-dialog',
  components: {
    'ep-spinner': Spinner
  },
  data () {
    return {
      showSpinner: false,
      label: {
        CANCEL: 'Cancel',
        ACCEPT: 'Yes'
      }
    }
  },
  computed: {
    ...mapState('app', [
      'areYouSureDetails'
    ])
  },
  methods: {
    ...mapActions('app', [
      'closeDialog'
    ]),
    onYes () {
      this.areYouSureDetails.callback()
      this.showSpinner = true
    }
  }
}
</script>

<style lang="scss" scoped>
@import '~assets/styles/theme';

.are-you-sure-dialog {
  position: relative;
  display: block;
  background: #FFFFFF;
  width: $dialog-width;
}

.content {
  position: relative;
  padding: 40px 20px;
  margin: auto;
  text-align: center;
}

.text-content {
  text-align: left;
}

.cancel-btn {
  font-size: 18px;
  font-weight: bold;
  border: none;
  padding: 8px 16px;
  color: #fff;
  border-radius: 2px;
  text-decoration: none;
  background-color: $gray;
}

.accept-btn {
  @extend .cancel-btn;
  background-color: $form-primary-color;
}

.accept-btn-container, .cancel-btn-container {
  display: inline-block;
}

.spinner-icon-container {
  margin-top: 16px;
}
</style>
